#!/bin/awk -f
#
# grind song-by-title index from name-map and name-list.
#
# name-map comes first in the form:
#   canonical-name:human-readable-name
# examples:
#   artist:Artist Name
#   artist/album:Album Title
#   artist/album/song:Song Title
#
# then name-list in the form:
#   canonical-name
# examples:
#   artist/album/song.mp3
#

BEGIN {
#    print "<table>"
}

# old style tag file with just name
/^[^:]*:[^:=]*$/ {
    split($0,a,":")
    namemap[a[1]]=a[2]
}

/:N=/ {
    split($0,a,":")
    i=index($0,"=")
    namemap[a[1]]=substr($0,i+1)
}

/:T=/ {
    split($0,a,":")
    i=index($0,"=")
    timemap[a[1]]=substr($0,i+1)
}

!/:/ {
    canon=$1
    names=$1
    if (names ~ /\.mp3$/) {
	names=substr(names, 1, length(names)-4)
    }
    nel=split(names,a,"/");
    aa[1]=a[1]
    for (i = 2; i <= nel; i++) {
	aa[i]=aa[i-1] "/" a[i]
    }
    time=timemap[names];
    if (namemap[aa[nel-2]] != "") {
	b[1]=namemap[aa[nel-2]]
    } else {
	b[1]=a[nel-2]
    }
    if (namemap[aa[nel-1]] != "") {
	b[2]=namemap[aa[nel-1]]
    } else {
	b[2]=a[nel-1]
    }
    if (namemap[aa[nel]] != "") {
	b[3]=namemap[aa[nel]]
    } else {
	b[3]=a[nel]
    }
    title=b[3]
    print "<tr><td width=40%><a href=\"/cgi-bin/tuneput.cgi?" canon "\">" title "</a></td><td>" time "</td><td>" b[1] " / " b[2] "</td></tr>"
}

END {
#    print "</table>"
}

