#!/usr/bin/perl
#
# dynindex.cgi
#
# 2001-6-2 manchek
#
# dynamically generate html for albums index
#

########################################################################
# perl script boilerplate.
# set tunebot root and load utility module.
#
BEGIN {
    $tunebot_root="XXX-the-tunebot-install-root";
    @INC=($tunebot_root."/lib", @INC);
}
use Tunebot;
#
# end of perl boilerplate
########################################################################

$debug=0;

## ixbkt
#
# get the index bucket tag for a string
#
sub ixbkt {
   my ($a) = @_;
   $a = substr($a, 0, 1);
   if ($a ge "A" && $a le "Z") {
	return $a;
   } elsif ($a ge "a" && $a le "z") {
	return uc($a);
   } else {
	return "A";
   }
}

#
# spit out html top boilerplate
#
print "Content-type: text/html\n";
print "\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "<head>\n";
print "<title>".$configs{BANNER_STRING}." Dynamic Fast Tunes by Artist </title>\n";
print "</head>\n";
open(I, $tunebot_root."/html/bodypart.html.head");
while ($line = <I>) {
    print $line;
}
close(I);

Tunebot::suckInPostGet;

Tunebot::suckInTags();
Tunebot::suckInAutotags();

print "<center><font size=+2>Dynamic Fast Tunes by Artist </font>\n";
print "<br>click to make a request</center>\n";
if ($posts{"abn"} ne "") {
    $albnum=$posts{"abn"};
    renderAlbums($albnum, 20);
}

#
# html bottom boilerplate
#
open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0;

sub renderAlbums {
    $albnum=$_[0];
    $trknum=$autotags{$autotags{"IXA/AB/$albnum", "PATH"}, "IXA_FTA"};
    $count = $_[1];
    $indent = 0;
    $lastar = "";
    $lastal = "";
    $lastalf = substr($cb, 0, 1);

    $lastalf = chr(ord($lastalf) - 1);

    if ($albnum > 1) {
	$previouspage = $albnum - $count;
	if ($previouspage < 1) {
	    $previouspage = 1;
	}
    } else {
	$previouspage = 0;
    }
    if ($albnum + $count <= $autotags{"IXA", "NAB"}) {
	$nextpage = $albnum + $count;
    } else {
	$nextpage = 0;
    }
    ++$count;
    TRACK: while ($count > 0) {
	$path=$autotags{"IXA/TK/$trknum", "PATH"};
	last TRACK if ($path eq "");

	@raw = split('/', $path);
	$n = $#raw;
	$artistfile = join("/", @raw[0..$n-2]);
	$artist = $tags{$artistfile, "N"};
	if ($artist eq "") {
	    $artist = $raw[$n-2];
	}
	$sartist = $tags{$artistfile, "SORT"};
	if ($sartist eq "") {
	    $sartist = $artist;
	}
	$albumfile = join("/", @raw[0..$n-1]);
	$album = $tags{$albumfile, "N"};
	if ($album eq "") {
	    $album = $raw[$n-1];
	}
	$track = $tags{$path, "N"};
	if ($track eq "") {
	    $track = $raw[$n];
	}
	if ($tags{$path, "ARTIST"} ne "") {
	    $track = $track . "<em> - " . $tags{$path, "ARTIST"} . "</em>";
	}
#	@aat = split('/', $render{$sartist});
	$i = 2;
	if ($artist ne $lastar) {
	    $i = 0;
	} elsif ($album ne $lastal) {
	    $i = 1;
	}
	if ($i != 2) {
	    --$count;
	    last TRACK if ($count < 1);
	}
	$lastar = $artist;
	$lastal = $album;
#print "<br> $i $path $artist $album $track \n";

	while ($indent > $i) {
	    if ($indent == 2) {
#		print "</table></td><td align=center>X</td></tr></table>\n"
		if ($albumicon ne "") {
		    print "</table></td><td align=center><img src=\"$albumicon\"></td></tr></table>\n"
		} else {
		    print "</table></td><td align=center></td></tr></table>\n"
		}
	    }
	    if ($indent == 1) {
		print "</ul>\n"
	    }
	    $indent--;
	}
	$i = 2;
	while ($indent < $i) {
	    $t = 1;
	    $indent++;
	    if ($indent == 1) {
		while ($lastalf lt ixbkt($sartist)) {
		    $lastalf = chr(ord($lastalf) + 1);
		    print "<a name=\"", $lastalf, "\">\n";
		}
		print "<a name=\"", $artist, "\">\n";
		print "<table width=50%>\n";
		print "<tr><td align=left><p><font size=+2>", $artist, "</font></td>\n";
		print "<td align=right>\n";
		print "<table>\n";
		print "<tr><td colspan=3 align=center><a href=\"#TOPOFILE\">\n";
		print "<img src=\"/rfm/upto.gif\" alt=\"topOfPage\" border=0></a></td></tr>\n";
		print "<tr><td align=center>";
		if ($previouspage > 0) {
		    print "<a href=\"/cgi-bin/dynindex.cgi?abn=$previouspage\"><img src=\"/rfm/upup.gif\" alt=\"previousPage\" border=0></a>\n";
		}
		print "</td>\n";
		print "<td align=center><a href=\"/rfm/artists.html\"><img src=\"/rfm/ana.gif\" alt=\"to Index\" border=0></a></td>\n";
		print "<td align=center>";
		if ($nextpage > 0) {
		    print "<a href=\"/cgi-bin/dynindex.cgi?abn=$nextpage\"><img src=\"/rfm/downdown.gif\" alt=\"nextPage\" border=0></a>\n";
		}
		print "</td></tr>\n";
		print "<tr><td colspan=3 align=center><a href=\"#ENDOFILE\">\n";
		print "<img src=\"/rfm/downto.gif\" alt=\"bottomOfPage\" border=0></a></td></tr>\n";
		print "</table>\n";
		print "</td>\n";
		print "</tr>\n";
		print "</table>\n";
		print "<ul>\n";
	    } elsif ($indent == 2) {
		print "<a name=\"", $artist, "/", $album, "\">\n";
		print "<li><b> $album </b>\n";
		print "<a href=\"/cgi-bin/tuneput.cgi?album=" . $albumfile . "\"><img border=0 align=middle alt=\"Play\" src=\"/rfm/play.gif\"></a>\n";
		print "<a href=\"/cgi-bin/playalbum.cgi?album=" . $albumfile . "\"><img border=0 align=middle alt=\"Play Selected Tracks\" src=\"/rfm/playoption.gif\"></a>\n";
		if ($tags{$albumfile, "DATE"} ne "") {
		    print "<br><em>" . $tags{$albumfile, "DATE"} . "</em>\n";
		}
#		print "<table width=50% cellpadding=0>\n";
		print "<table width=90% cellpadding=0>\n";
		print "<tr><td width=60%>\n";
		print "<table width=100% cellpadding=0>\n";
if ($tags{$albumfile, "ICON"} ne "") {
    $albumicon=$albumfile . "/" . $tags{$albumfile, "ICON"};
    $albumicon =~ s/^\///;
    $albumicon =~ s/\//./g;
    $albumicon="/rfm/icons/". $albumicon;
} else {
    $albumicon="";
}
	    }
	}
	$ttime = $tags{$path, "T"};
	print "<tr>";
	print "<td align=right><font size=-1>$t.</font> <a href=\"/cgi-bin/tuneput.cgi?$path.mp3";
	$t++;
	print $canons{$sortk};
	print "\">";
	print $track;
	print "</a></td>";
	print "<td width=25% align=center><a href=\"/cgi-bin/abouttrack.cgi?";
	print $canons{$sortk};
	print "\">", $ttime, "</a></td>\n";
	print "</tr>\n";

	++$trknum;
    }
    while ($indent > 0) {
	if ($indent == 2) {
	    if ($albumicon ne "") {
		print "</table></td><td align=center><img src=\"$albumicon\"></td></tr></table>\n"
	    } else {
		print "</table></td><td align=center></td></tr></table>\n"
	    }
	}
	if ($indent == 1) {
	    print "</ul>\n"
	}
	$indent--;
    }

    print "<table width=50%>\n";
    print "<tr><td></td>\n";
    print "<td align=right>\n";
    print "<table>\n";
    print "<tr><td colspan=3 align=center><a href=\"#TOPOFILE\">\n";
    print "<img src=\"/rfm/upto.gif\" alt=\"topOfPage\" border=0></a></td></tr>\n";
    print "<tr><td align=center>";
    if ($previouspage > 0) {
	print "<a href=\"/cgi-bin/dynindex.cgi?abn=$previouspage\"><img src=\"/rfm/upup.gif\" alt=\"previousPage Back\" border=0></a>\n";
    }
#    if ($isprev) {
#	print "<a href=\"tunesbyartist", $prevcb, ".html\"><img src=\"/rfm/upup.gif\" alt=\"browse Back\" border=0></a>\n";
#    }
    print "</td>\n";
    print "<td align=center><a href=\"/rfm/artists.html\"><img src=\"/rfm/ana.gif\" alt=\"to Index\" border=0></a></td>\n";
    print "<td align=center>";
    if ($nextpage > 0) {
	print "<a href=\"/cgi-bin/dynindex.cgi?abn=$nextpage\"><img src=\"/rfm/downdown.gif\" alt=\"nextPage\" border=0></a>\n";
    }
    print "</td></tr>\n";
    print "<tr><td colspan=3 align=center><a href=\"#ENDOFILE\">\n";
    print "<img src=\"/rfm/downto.gif\" alt=\"bottomOfPage\" border=0></a></td></tr>\n";
    print "</table>\n";
    print "</td>\n";
    print "</tr>\n";
    print "</table>\n";
}

