#!/bin/sh
#
# whack a tune from the queue
#

TUNEBOT_ROOT=XXX-the-tunebot-install-root
source $TUNEBOT_ROOT/settings

function lookupvar() {
    grep "^$2=" $1 |sed -e "s/^$2=//"
}

function lookupbool() {
    case ` grep "^$2=" $1 |sed -e "s/^$2=//" ` in
    [1-9]* | [Oo][Nn] | [Tt][Rr][Uu][Ee] | [Yy][Ee][Ss] | [TtYy] )
	echo 1
	;;
    * )
	echo 0
	;;
    esac
}

function lookupint() {
    lookupint=` lookupvar "$1" "$2" `
    case "$lookupint" in
    [0-9]* | -[0-9]* )
	echo "$lookupint"
	;;
    +[0-9]* )
	echo "$lookupint" |sed -e 's/^+//'
	;;
    * )
	echo 0
	;;
    esac
}

function boolify() {
    case "$1" in
    [1-9]* | [Oo][Nn] | [Tt][Rr][Uu][Ee] | [Yy][Ee][Ss] | [TtYy] )
	echo 1
	;;
    * )
	echo 0
	;;
    esac
}

function storevar() {
    grep -v "^$2=" $1 > /tmp/tunectl.$$
    echo "$2=$3" >> /tmp/tunectl.$$
    cat /tmp/tunectl.$$ > $1
    rm -f /tmp/tunectl.$$
}

varname=` echo "$QUERY_STRING" | sed -e 's/=.*//' `
varval=` echo "$QUERY_STRING" | sed -e 's/^[^=]*=//' `

case "x$QUERY_STRING" in
x?* )
    PREEMPT_Q_PERC=` lookupint $CONTROLS PREEMPT_Q_PERC `
    RANDOM_FROM_Q=` lookupbool $CONTROLS RANDOM_FROM_Q `
    RANDOM_IF_IDLE=` lookupbool $CONTROLS RANDOM_IF_IDLE `
    FILLET_TIME=` lookupint $CONTROLS FILLET_TIME `
    HOWMANY_TUNES=` lookupint $CONTROLS HOWMANY_TUNES `
    MYSTERY_PARAM=` lookupbool $CONTROLS MYSTERY_PARAM `
    echo 'Content-type: text/html'
    echo ''
    echo '<html>'
    echo '<head>'
    echo '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
    echo '<META HTTP-EQUIV=REFRESH CONTENT="0; URL=tunectl.cgi">'
    echo "<title>$BANNER_STRING TuneControl</title>"
    echo '</head>'

    case "x$QUERY_STRING" in
    x?* )
	case "$varname" in
	PREEMPT_Q_PERC )
	    case "$varval" in
	    [0-9]* )
		PREEMPT_Q_PERC="$varval"
		;;
	    esac
	    storevar $CONTROLS PREEMPT_Q_PERC "$PREEMPT_Q_PERC"
	    ;;
	RANDOM_FROM_Q )
	    storevar $CONTROLS RANDOM_FROM_Q "$varval"
	    ;;
	RANDOM_IF_IDLE )
	    storevar $CONTROLS RANDOM_IF_IDLE "$varval"
	    ;;
	FILLET_TIME )
	    storevar $CONTROLS FILLET_TIME "$varval"
	    ;;
	HOWMANY_TUNES )
	    case "$varval" in
	    [0-9]* )
		HOWMANY_TUNES="$varval"
		;;
	    esac
	    storevar $CONTROLS HOWMANY_TUNES "$HOWMANY_TUNES"
	    ;;
	MYSTERY_PARAM )
	    storevar $CONTROLS MYSTERY_PARAM "$varval"
	    ;;
	esac
	d=` date '+%Y%m%d%H%M' `
	echo "DATE=$d HOST=$REMOTE_ADDR CONTROL=$varname VALUE=$varval" >> $TUNEBOT_ROOT/feedback
	;;
    esac
    exit 0
esac

echo 'Content-type: text/html'
echo ''
echo '<html>'
echo '<head>'
echo '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
echo "<title>$BANNER_STRING TuneControl</title>"
echo '</head>'
cat $TUNEBOT_ROOT/html/bodypart.html.head
#echo '<pre>'
#env|sort
#echo '</pre>'

PREEMPT_Q_PERC=` lookupint $CONTROLS PREEMPT_Q_PERC `
RANDOM_FROM_Q=` lookupbool $CONTROLS RANDOM_FROM_Q `
RANDOM_IF_IDLE=` lookupbool $CONTROLS RANDOM_IF_IDLE `
FILLET_TIME=` lookupint $CONTROLS FILLET_TIME `
HOWMANY_TUNES=` lookupint $CONTROLS HOWMANY_TUNES `
MYSTERY_PARAM=` lookupbool $CONTROLS MYSTERY_PARAM `

echo '<center>'
echo "<font size=+1>Control Panel</font>"
echo '</center>'
echo '<p>'
echo '<table width=75% align=center>'
echo '<tr><th align=left>Control</th><th>Value</th><th>Modify</th></tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Probability of playing a random tune before a request</td>'
echo "<td align=center>$PREEMPT_Q_PERC %</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?PREEMPT_Q_PERC=50">50</a> :'
echo '<a href="tunectl.cgi?PREEMPT_Q_PERC=30">30</a> :'
echo '<a href="tunectl.cgi?PREEMPT_Q_PERC=20">20</a> :'
echo '<a href="tunectl.cgi?PREEMPT_Q_PERC=10">10</a> :'
echo '<a href="tunectl.cgi?PREEMPT_Q_PERC=0">0</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Play requests in random order</td>'
echo "<td align=center>$RANDOM_FROM_Q</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?RANDOM_FROM_Q=1">Yes</a> :'
echo '<a href="tunectl.cgi?RANDOM_FROM_Q=0">No</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Play random tunes when no requests (no dead air)</td>'
echo "<td align=center>$RANDOM_IF_IDLE</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?RANDOM_IF_IDLE=1">Yes</a> :'
echo '<a href="tunectl.cgi?RANDOM_IF_IDLE=0">No</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Play fillet after some minutes</td>'
echo "<td align=center>$FILLET_TIME</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?FILLET_TIME=30">30</a> :'
echo '<a href="tunectl.cgi?FILLET_TIME=45">45</a> :'
echo '<a href="tunectl.cgi?FILLET_TIME=60">60</a> :'
echo '<a href="tunectl.cgi?FILLET_TIME=90">90</a> :'
echo '<a href="tunectl.cgi?FILLET_TIME=120">120</a> :'
echo '<a href="tunectl.cgi?FILLET_TIME=0">don'"'"'t</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Default number of tunes to show in Whuzzon</td>'
echo "<td align=center>$HOWMANY_TUNES</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=50">50</a> :'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=20">20</a> :'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=10">10</a> :'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=5">5</a> :'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=2">2</a> :'
echo '<a href="tunectl.cgi?HOWMANY_TUNES=1">1</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '<tr>'
echo '<td>Some mystery parameter</td>'
echo "<td align=center>$MYSTERY_PARAM</td>"
echo '<td align=center>'
echo '<a href="tunectl.cgi?MYSTERY_PARAM=1">Yes</a> :'
echo '<a href="tunectl.cgi?MYSTERY_PARAM=0">No</a>'
echo '</td>'
echo '</tr>'

echo '<tr><td colspan=3><hr></td></tr>'
echo '</table>'
echo '<p>'
cat $TUNEBOT_ROOT/html/bodypart.html.tail
echo '</html>'
exit 0

