#!/bin/sh
#
# list the tune currently playing, ones recently played, and ones in the q.
#

TUNEBOT_ROOT=XXX-the-tunebot-install-root
source $TUNEBOT_ROOT/settings

# look up a variable ($2) in the controls file ($1)
function lookupvar() {
    if [ -r $1 ]; then
	grep "^$2=" $1 |sed -e "s/^$2=//"
    else
	echo 0
    fi
}

# look up a boolean value in the controls file
function lookupbool() {
    case ` grep "^$2=" $1 |sed -e "s/^$2=//" ` in
    [1-9]* | [Oo][Nn] | [Tt][Rr][Uu][Ee] | [Yy][Ee][Ss] | [TtYy] )
	echo 1
	;;
    * )
	echo 0
	;;
    esac
}

# look up an integer value in the controls file
function lookupint() {
    lookupint=` lookupvar "$1" "$2" `
    case "$lookupint" in
    [0-9]* | -[0-9]* )
	echo "$lookupint"
	;;
    +[0-9]* )
	echo "$lookupint" |sed -e 's/^+//'
	;;
    * )
	echo 0
	;;
    esac
}

case "$QUERY_STRING" in
[0-9]* )
    export HOWMANY_TUNES="$QUERY_STRING"
    ;;
* )
    export HOWMANY_TUNES=` lookupint $CONTROLS HOWMANY_TUNES `
    ;;
esac
export RANDOM_FROM_Q=` lookupbool $CONTROLS RANDOM_FROM_Q `
export TUNEBOT_ROOT
export QDIR
export BANNER_STRING
exec $TUNEBOT_BIN/tuneq.perl

